__all__ = ['ExpressionChecker']

import astroid as _astroid

from src.qchecker.checker.abc_checker import ABChecker as _ABChecker


class ExpressionChecker(_ABChecker):
    def uses_starred(self, components=None, excluding=None):
        return self.uses(_astroid.Starred, components, excluding)

    def uses_comprehension(self, components=None, excluding=None):
        return self.uses(_astroid.Comprehension, components, excluding)

    def uses_list_comprehension(self, components=None, excluding=None):
        return self.uses(_astroid.ListComp, components, excluding)

    def uses_set_comprehension(self, components=None, excluding=None):
        return self.uses(_astroid.SetComp, components, excluding)

    def uses_dict_comprehension(self, components=None, excluding=None):
        return self.uses(_astroid.DictComp, components, excluding)
