__all__ = ['LoopChecker']

import astroid as _astroid

from src.qchecker.checker.abc_checker import ABChecker as _ABChecker


class LoopChecker(_ABChecker):
    def uses_for(self, components=None, excluding=None) -> bool:
        return self.uses(_astroid.For, components, excluding)

    def uses_while(self, components=None, excluding=None):
        return self.uses(_astroid.While, components, excluding)

    def count_for(self, components=None, excluding=None):
        return len(tuple(self.nodes_of_class(_astroid.For, components, excluding)))

    def count_while(self, components=None, excluding=None):
        return len(tuple(self.nodes_of_class(_astroid.While, components, excluding)))

    def max_for_loop_nesting(self, components=None, excluding=None):
        return self.max_nesting(components, excluding, _astroid.For)

    def max_while_loop_nesting(self, components=None, excluding=None):
        return self.max_nesting(components, excluding, _astroid.While)

    def uses_nested_for(self, components=None, excluding=None):
        return self.max_for_loop_nesting(components, excluding) > 1

    def uses_nested_while(self, components=None, excluding=None):
        return self.max_while_loop_nesting(components, excluding) > 1
