import abc as _abc
import sys as _sys


class ABConstraints(metaclass=_abc.ABCMeta):
    @staticmethod
    def prevent(predicate, msg, exit_on_error=False):
        if predicate:
            print(msg, file=_sys.stderr)
            if exit_on_error:
                _sys.exit(1)
            return False
        return True

    @staticmethod
    def require(predicate, msg, exit_on_error=False):
        if not predicate:
            print(msg, file=_sys.stderr)
            if exit_on_error:
                _sys.exit(1)
            return False
        return True

    @staticmethod
    def std_prevent_msg(element, msg=None, verb='use'):
        if msg is not None:
            return msg
        return f'You must not {verb} {element} in your code.'

    @staticmethod
    def std_require_msg(element, msg=None, verb='use'):
        if msg is not None:
            return msg
        return f'You must {verb} {element} in your code.'
