from src.qchecker import ClassChecker as _ClassChecker
from src.qchecker.constraints.abc_constraints import ABConstraints as _ABConstraints

__all__ = ['ClassConstraints']


class ClassConstraints(_ABConstraints, _ClassChecker):
    def require_class_definition(self, class_names=None, require_all=True, components=None, excluding=None, msg=None,
                                 exit_on_error=False):
        if class_names is None:
            msg = self.std_require_msg('a class', msg, verb='define')
        else:
            msg = self.std_require_msg(f'the {class_names} class', msg, verb='define')
        return self.require(self.defines_class(class_names, require_all, components, excluding),
                            msg, exit_on_error)

    def prevent_class_definition(self, class_names=None, require_all=False, components=None, excluding=None, msg=None,
                                 exit_on_error=False):
        if class_names is None:
            msg = self.std_prevent_msg('any classes', msg, verb='define')
        else:
            msg = self.std_prevent_msg(f'the {class_names} class', msg, verb='define')
        return self.prevent(self.defines_class(class_names, require_all, components, excluding),
                            msg, exit_on_error)

    def require_class_initialization(self, classes=None, require_all=True, components=None, excluding=None, msg=None,
                                     exit_on_error=False):
        if classes is None:
            msg = self.std_require_msg('a class', msg, 'initialize')
        else:
            msg = self.std_require_msg(f'the {classes} class', msg, 'initialize')
        return self.require(self.initializes_class(classes, require_all, components, excluding),
                            msg, exit_on_error)

    def prevent_class_initialization(self, classes=None, require_all=False, components=None, excluding=None, msg=None,
                                     exit_on_error=False):
        if classes is None:
            msg = self.std_prevent_msg('any classes', msg, 'initialize')
        else:
            msg = self.std_prevent_msg(f'the {classes} class', msg, 'initialize')
        return self.require(self.initializes_class(classes, require_all, components, excluding),
                            msg, exit_on_error)
