import sys as _sys

from .classes import ClassConstraints as _ClassConstraints
from .expressions import ExpressionsConstraints as _ExpressionsConstraints
from .functions import FunctionConstraints as _FunctionConstraints
from .loops import LoopConstraints as _LoopConstraints

__all__ = ['Constraints']


class Constraints(_ClassConstraints, _ExpressionsConstraints, _FunctionConstraints, _LoopConstraints):
    def force_for(self, exit_on_error=False):
        passes = self.prevent_class_definition()
        passes &= self.prevent_starred()
        passes &= self.prevent_comprehension()
        passes &= self.prevent_recursion()
        passes &= self.prevent_while()
        passes &= self.require_for()

        if not passes and exit_on_error:
            _sys.exit(1)

    def force_while(self, exit_on_error=False):
        passes = self.prevent_class_definition()
        passes &= self.prevent_starred()
        passes &= self.prevent_comprehension()
        passes &= self.prevent_recursion()
        passes &= self.prevent_for()
        passes &= self.require_while()

        if not passes and exit_on_error:
            _sys.exit(1)
