from src.qchecker import ExpressionChecker as _ExpressionChecker
from src.qchecker.constraints.abc_constraints import ABConstraints as _ABConstraints

__all__ = ['ExpressionsConstraints']


class ExpressionsConstraints(_ABConstraints, _ExpressionChecker):
    def prevent_starred(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('starred expressions', msg)
        return self.prevent(self.uses_starred(components, excluding), msg, exit_on_error)

    def require_starred(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('a starred expression', msg)
        return self.require(self.uses_starred(components, excluding), msg, exit_on_error)

    def prevent_comprehension(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('comprehension', msg)
        return self.prevent(self.uses_comprehension(components, excluding), msg, exit_on_error)

    def require_comprehension(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('comprehension', msg)
        return self.require(self.uses_comprehension(components, excluding), msg, exit_on_error)

    def prevent_list_comprehension(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('list comprehension', msg)
        return self.prevent(self.uses_list_comprehension(components, excluding), msg, exit_on_error)

    def require_list_comprehension(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('list comprehension', msg)
        return self.require(self.uses_list_comprehension(components, excluding), msg, exit_on_error)

    def prevent_set_comprehension(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('set comprehension', msg)
        return self.prevent(self.uses_set_comprehension(components, excluding), msg, exit_on_error)

    def require_set_comprehension(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('set comprehension', msg)
        return self.require(self.uses_set_comprehension(components, excluding), msg, exit_on_error)

    def prevent_dict_comprehension(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('dict comprehension', msg)
        return self.prevent(self.uses_dict_comprehension(components, excluding), msg, exit_on_error)

    def require_dict_comprehension(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('dict comprehension', msg)
        return self.require(self.uses_dict_comprehension(components, excluding), msg, exit_on_error)
