from src.qchecker import LoopChecker as _LoopChecker
from src.qchecker.constraints.abc_constraints import ABConstraints as _ABConstraints

__all__ = ['LoopConstraints']


class LoopConstraints(_ABConstraints, _LoopChecker):
    def prevent_for(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('for loops', msg)
        return self.prevent(self.uses_for(components, excluding), msg, exit_on_error)

    def require_for(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('a for loop', msg)
        return self.require(self.uses_for(components, excluding), msg, exit_on_error)

    def prevent_while(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('while loops', msg)
        return self.prevent(self.uses_while(components, excluding), msg, exit_on_error)

    def require_while(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('a while loop', msg)
        return self.require(self.uses_while(components, excluding), msg, exit_on_error)

    def prevent_nested_for(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('nested for loops', msg)
        return self.prevent(self.uses_nested_for(components, excluding), msg, exit_on_error)

    def require_nested_for(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('a nested for loop', msg)
        return self.require(self.uses_nested_for(components, excluding), msg, exit_on_error)

    def prevent_nested_while(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_prevent_msg('nested while loops', msg)
        return self.prevent(self.uses_nested_while(components, excluding), msg, exit_on_error)

    def require_nested_while(self, components=None, excluding=None, msg=None, exit_on_error=False):
        msg = self.std_require_msg('a nested while loop', msg)
        return self.require(self.uses_nested_while(components, excluding), msg, exit_on_error)
